/*------------------SAX XMLڿ ϱ-------------------------------
1.ʿ Ŭ Ʈ
2.SAX ļ ü 
3.̺Ʈ ڵ鷯 Ŭ 
	3.1 XML ڿ    
4.̺Ʈ ޼ 
	4.1   - <?xml version="1.0" encoding="euc-kr"?> ڿ 
	4.2 PI  = <?Ÿ ?> ڿ 
	4.3   - <Ҹ Ӽ="Ӽ"> ڿ 
	4.3.1 Ӽ   Ӽ ó
	4.4   -   ڿ 
	4.5   - </Ҹ> ڿ 
	4.6   -  ڿ Ͽ 
5.̺Ʈ ڵ鷯 ü 
6.SAXParser.parse()޼ ̺Ʈ ڵ鷯   XML  Ľ
-----------------------------------------------------------------------*/
//1.
import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.SAXParser;
import org.xml.sax.Attributes;
import org.xml.sax.helpers.DefaultHandler;

public class  PrintString {

	public static void main(String[] args){
		
		try{
			//2.
			SAXParserFactory factory = SAXParserFactory.newInstance();
			SAXParser parser = factory.newSAXParser();

			//5.
			DefaultHandler handler = new EventHandler();
			//6.
			parser.parse("members.xml", handler);
			
		}catch(Exception e){
			e.printStackTrace(System.err);
		}
	}
}

//3.
class EventHandler extends DefaultHandler		
{
	//3.1.
	static String xmlstr[] = new String[1000];
	static int lineNum = 0;
	static String indent = "";
	
	//4.1
	public void startDocument(){
		xmlstr[lineNum] = "<?xml version=\"1.0\" encoding=\"euc-kr\"?>";
		lineNum++;
	}
	
	//4.2
	public void processingInstruction(String target, String data){
		
		xmlstr[lineNum] = "<?"+ target + " " + data + "?>";
		lineNum++;
	}

	//4.3
	public void startElement(String uri, String localName, String qName, Attributes atts){

		xmlstr[lineNum] = indent + "<" + qName;


		if(atts.getLength() != 0){
			for(int i = 0 ; i < atts.getLength() ; i++){
				xmlstr[lineNum] += " " + atts.getQName(i) + "=\"" + atts.getValue(i) + "\"";
			}
		}
		xmlstr[lineNum] += ">";


		lineNum++;
		indent += "  ";
	}
	
	//4.4.
	public void characters(char[] ch, int start, int len){
		String strChar = new String(ch, start, len);
		if (strChar.trim().length() != 0)
		{
			xmlstr[--lineNum] += new String(ch, start, len);
		}
	}

	//4.5
	public void endElement(String uri, String localName, String qName){
		
		indent = indent.substring(0, indent.length() - 2);

		if (xmlstr[lineNum] != null)
		{
			xmlstr[lineNum] += "</" + qName + ">";
		}else{
			xmlstr[lineNum] = indent + "</" + qName + ">";
		}
		lineNum++;
	}

	//4.6.
	public void endDocument(){
		for (int i = 0;i < lineNum ; i++ )
		{
			System.out.println(xmlstr[i]);
		}
	}

}
