/*---------------------DOM2DOM-XSLT ȯ---------------------------
1. ʿ Ŭ Ʈ
2. XML  / ʿ PhysicalCheck Ŭ 
3. ڿ ° XML  ڵ ִ PhysicalCheck()  
4.  л ü˻  ߰ϴ addStudent() ޼ 
5. XSLT ȯ ۾ ʿ TransformData Ŭ 
6.  XML   XSLT ŸϽƮ ȯϴ transform() ޼ 
7. XML  ڿ   serialize() ޼ 
8. main() ޼ 
------------------------------------------------------------------*/
//1.DOM2DOM-XSLT ȯ ʿ Ŭ Ʈ
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;

import javax.xml.transform.TransformerFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.Templates;

import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.dom.DOMResult;

import org.apache.xalan.serialize.Serializer;
import org.apache.xalan.serialize.SerializerFactory;
import org.apache.xalan.templates.OutputProperties;

import org.w3c.dom.*;
import java.io.File;
import java.io.StringWriter;
import java.util.Properties;

public class DOM2DOM{
	//8.
	public static void main(String[] args){
	
		//г   
		String strGrade = "3";
		String strClass = "1";

		//ü˻ ü  - XML  
		PhysicalCheck pc = new PhysicalCheck(strGrade, strClass);

		//л ü˻  ߰ - XML   ߰
		pc.addStudent("ȣ", "180", "90");
		pc.addStudent("", "180", "65");
		pc.addStudent("缮", "177", "61");

		//XSLT ȯ ó  TransformData ü 
		TransformData td = new TransformData();

		//XSLT ȯ   Node result .
		Document result = (Document)td.transform(pc.doc, new File("PhysicalCheck.xsl"));

		//ȯ Document ü ˻Ͽ ü˻   
		String grade = result.getElementsByTagName("г").item(0).getFirstChild().getNodeValue();
		String squard = result.getElementsByTagName("г").item(0).getLastChild().getNodeValue();
		String numOfStudents = result.getElementsByTagName("л").item(0).getFirstChild().getNodeValue();
		String heightAvg = result.getElementsByTagName("Ű").item(0).getFirstChild().getNodeValue();
		String weightAvg = result.getElementsByTagName("ո").item(0).getFirstChild().getNodeValue();

		//ֿܼ ü˻  
		System.out.println( grade + "г" + squard  + " ü˻   Դϴ");
		System.out.println("-------------------------------------------------------------");
		System.out.println("  л  : " + numOfStudents );
		System.out.println("     Ű : " + heightAvg);
		System.out.println(" ո : " + weightAvg);
	}
};

//2.
class PhysicalCheck{
	Document doc = null;

	//3.
	public PhysicalCheck(String strGrade, String strClass){
		try{
			DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
			DocumentBuilder builder = factory.newDocumentBuilder();
			doc = builder.newDocument();

		}catch(Exception e){
			e.printStackTrace(System.err);	
		}
		
		Element root = doc.createElement("ü˻");
		root.setAttribute("г", strGrade);
		root.setAttribute("", strClass);

		doc.appendChild(root);
	}

	//4.
	public void addStudent(String strName, String strHeight, String strWeight){
		Element root = doc.getDocumentElement();

		Element student = doc.createElement("л");

		Element sName = doc.createElement("̸");
		sName.appendChild(doc.createTextNode(strName));

		Element sHeight = doc.createElement("Ű");
		sHeight.appendChild(doc.createTextNode(strHeight));

		Element sWeight = doc.createElement("");
		sWeight.appendChild(doc.createTextNode(strWeight));

		student.appendChild(sName);
		student.appendChild(sHeight);
		student.appendChild(sWeight);

		root.appendChild(student);
	}
};

//5.
class TransformData{

	//6
	public Node transform(Document xmlDoc, File xslStyle){
		DOMSource xmlSource = new DOMSource(xmlDoc);
		DOMSource xslt = null;
		DOMResult result = new DOMResult();

		try{
			DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
			factory.setNamespaceAware(true);
			DocumentBuilder builder = factory.newDocumentBuilder();
			xslt = new DOMSource(builder.parse(xslStyle));
			TransformerFactory TFactory = TransformerFactory.newInstance();
			Templates templates = TFactory.newTemplates(xslt);
			Transformer transformer = templates.newTransformer();
			transformer.transform(xmlSource, result);
		}catch(Exception e){
			e.printStackTrace(System.err);
		}

		return(result.getNode());
	}
	
	//7.
	public String serialize(Node node){
		StringWriter sw = new StringWriter();
		try{
			Properties properties = new Properties();
			properties.setProperty("version","1.0");
			properties.setProperty("encoding","UTF-8");
			properties.setProperty("indent","yes");
			properties.setProperty("standalone","no");

			Serializer serializer = SerializerFactory.getSerializer(OutputProperties.getDefaultMethodProperties("xml"));
			serializer.setOutputFormat(properties);
			serializer.setWriter(sw);
			serializer.asDOMSerializer().serialize(node);		
		}catch(Exception e){
			e.printStackTrace(System.err);
		}

		return(sw.toString());
	}
};
