<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="xml" />

<xsl:template match="book">
   <html>
      <head>
         <title>Online Book</title>
         <style>
            p {font-family: serif}
               .title {font-size: 18pt; font-family: sans-serif; line-height: 24pt; background-color: blue; color: white; text-align: center; padding-top: 3pt;}
               .subtitle {font-size: 18pt; font-family: serif; line-height: 20pt;}
               .header {text-align: right; font-size: 10pt; font-family: serif; line-height: 14pt; color: red; padding-bottom: 30pt;}
         </style>
      </head>
      <body>
         <p class="header">This is not the latest Fop documentation.</p>
         <p class="title">
            <xsl:value-of select="title" />
         </p>
         <xsl:apply-templates select="para" />
      </body>
   </html>
</xsl:template>
	
<xsl:template match="para">
   <p class="subtitle" style="padding-top: 20pt">
      <xsl:number format="1" />
      <xsl:text>) </xsl:text>
      <xsl:value-of select="subtitle" />
   </p>
   <p>
      <xsl:for-each select="text">
         <xsl:value-of select="." /><br />
      </xsl:for-each>
   </p>
</xsl:template>
</xsl:stylesheet>